"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable:no-any
var protocol_1 = require("@regax/protocol");
var common_1 = require("@regax/common");
var socket_1 = require("./socket");
var JS_WS_CLIENT_TYPE = 'js-websocket';
var JS_WS_CLIENT_VERSION = '0.0.1';
var socketEvents = common_1.values(socket_1.SocketEvent);
var Client = /** @class */ (function (_super) {
    __extends(Client, _super);
    function Client(opts) {
        var _this = _super.call(this) || this;
        _this.reqId = 0;
        _this.callbacks = {}; // request callbacks
        _this.routeMap = {}; // Map from request id to route
        _this.dict = {}; // route string to code
        _this.socket = new socket_1.RegaxWebSocket();
        _this.handshakeBuffer = {
            'sys': {
                type: JS_WS_CLIENT_TYPE,
                version: JS_WS_CLIENT_VERSION,
                rsa: {}
            },
            'user': {}
        };
        _this.useCrypto = false; // 是否加密
        _this.opts = {};
        if (opts)
            _this.config(opts);
        _this.socket.on(socket_1.SocketEvent.DATA, _this.onMessage.bind(_this));
        socketEvents.forEach(function (k) { return _this.socket.on(k, function (data) { return _this.emit(k, data); }); });
        return _this;
    }
    Client.prototype.decode = function (data) {
        var msg = protocol_1.Message.decode(data);
        if (msg.id > 0) {
            msg.route = this.routeMap[msg.id];
            delete this.routeMap[msg.id];
            if (!msg.route) {
                return;
            }
        }
        // TODO compress route
        msg.body = JSON.parse(protocol_1.strdecode(msg.body));
        return msg;
    };
    Client.prototype.encode = function (id, route, data) {
        var type = id ? protocol_1.MessageType.REQUEST : protocol_1.MessageType.NOTIFY;
        var msg = protocol_1.strencode(JSON.stringify(data));
        var compressRoute = 0;
        if (this.dict && this.dict[route]) {
            route = this.dict[route];
            compressRoute = 1;
        }
        return protocol_1.Message.encode(id, type, compressRoute, route, msg);
    };
    Client.prototype.sendMessage = function (id, route, data) {
        if (this.useCrypto && this.rsa) {
            var cache = JSON.stringify(data);
            var sig = this.rsa.signString(cache, 'sha256');
            data = JSON.parse(cache);
            data['__crypto__'] = sig;
        }
        var msg = this.encode(id, route, data);
        var packet = protocol_1.Package.encode(protocol_1.PackageType.DATA, msg);
        this.socket.send(packet);
    };
    Client.prototype.onMessage = function (data) {
        var msg = this.decode(data);
        if (!msg)
            return;
        if (!msg.id) {
            // server push message
            this.emit(msg.route, msg.body);
            return;
        }
        // if have a id then find the callback function with the request
        var cb = this.callbacks[msg.id];
        if (cb) {
            delete this.callbacks[msg.id];
            var resp = msg.body || {};
            if (resp.code && resp.code !== 200) {
                this.emit('error', common_1.RegaxError.create(resp.message, resp.code));
                cb.rej(common_1.RegaxError.create(resp.message || 'Server Error', resp.code));
            }
            else {
                cb.res(resp.data);
            }
        }
    };
    Client.prototype.connect = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, url, encrypt, reconnect, _b, maxReconnectAttempts, WS, reconnectAttempts;
            var _this = this;
            return __generator(this, function (_c) {
                if (opts)
                    this.config(opts);
                _a = this.opts, url = _a.url, encrypt = _a.encrypt, reconnect = _a.reconnect, _b = _a.maxReconnectAttempts, maxReconnectAttempts = _b === void 0 ? socket_1.DEFAULT_MAX_RECONNECT_ATTEMPTS : _b, WS = _a.WebSocket;
                if (encrypt && this.rsa) {
                    this.useCrypto = true;
                    this.rsa.generate(1024, '10001');
                    this.handshakeBuffer.sys.rsa = {
                        rsa_n: this.rsa.n.toString(16),
                        rsa_e: this.rsa.e
                    };
                }
                reconnectAttempts = 0;
                return [2 /*return*/, new Promise(function (res, rej) {
                        _this.socket.connect(url, { reconnect: reconnect, maxReconnectAttempts: maxReconnectAttempts, handshakeBuffer: _this.handshakeBuffer, WebSocket: WS });
                        var reject = function () {
                            if (reconnect && reconnectAttempts < maxReconnectAttempts) {
                                reconnectAttempts++;
                                return;
                            }
                            _this.off(socket_1.SocketEvent.CONNECTION, response);
                            rej(common_1.RegaxError.create('[regax-websocket] Connection refused'));
                        };
                        var response = function () {
                            _this.off(socket_1.SocketEvent.DISCONNECT, reject);
                            res();
                        };
                        _this.socket.once(socket_1.SocketEvent.CONNECTION, response);
                        _this.socket.once(socket_1.SocketEvent.DISCONNECT, reject);
                    })];
            });
        });
    };
    Client.prototype.disconnect = function () {
        this.socket.close();
    };
    Client.prototype.request = function (route, msg) {
        if (msg === void 0) { msg = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (res, rej) {
                        if (!route) {
                            return;
                        }
                        _this.reqId++;
                        _this.callbacks[_this.reqId] = { res: res, rej: rej };
                        _this.routeMap[_this.reqId] = route;
                        _this.sendMessage(_this.reqId, route, msg);
                    })];
            });
        });
    };
    Client.prototype.notify = function (route, msg) {
        if (msg === void 0) { msg = {}; }
        this.sendMessage(0, route, msg);
    };
    Client.prototype.config = function (opts) {
        Object.assign(this.opts, opts);
        if (opts.user)
            this.handshakeBuffer.user = opts.user;
        if (opts.rsa)
            this.rsa = opts.rsa;
    };
    return Client;
}(common_1.EventEmitter));
exports.Client = Client;
//# sourceMappingURL=client.js.map